package cn.com.ctop.crawler.modules.appium.service.impl;

import cn.com.ctop.crawler.modules.appium.entity.AppiumDevice;
import cn.com.ctop.crawler.modules.appium.entity.AppiumTask;
import cn.com.ctop.crawler.modules.appium.entity.AppiumTaskItem;
import cn.com.ctop.crawler.modules.appium.entity.AppiumTaskLog;
import cn.com.ctop.crawler.modules.appium.mapper.AppiumTaskMapper;
import cn.com.ctop.crawler.modules.appium.service.IAppiumDeviceService;
import cn.com.ctop.crawler.modules.appium.service.IAppiumTaskItemService;
import cn.com.ctop.crawler.modules.appium.service.IAppiumTaskLogService;
import cn.com.ctop.crawler.modules.appium.service.IAppiumTaskService;
import cn.com.ctop.crawler.modules.core.util.AppiumUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import io.appium.java_client.android.AndroidDriver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 任务表
 * @author jeecg-boot
 * @date 2019-10-31
 * @version V1.0
 */
@Service
public class AppiumTaskServiceImpl extends ServiceImpl<AppiumTaskMapper, AppiumTask> implements IAppiumTaskService {
    @Autowired
    private IAppiumTaskItemService iAppiumTaskItemService;
    @Autowired
    private IAppiumDeviceService iAppiumDeviceService;
    @Autowired
    private IAppiumTaskLogService iAppiumTaskLogService;

    public void runTask(Integer taskId, Integer deviceId) {
        AppiumTask task = this.getById(taskId);
        AppiumDevice appiumDevice = iAppiumDeviceService.getById(deviceId);
        appiumDevice.setStatus(2);
        iAppiumDeviceService.updateById(appiumDevice);
        AppiumTaskLog log = new AppiumTaskLog();
        log.setDeviceId(deviceId);
        log.setDeviceIp(appiumDevice.getIp());
        log.setDevicePort(appiumDevice.getPort());
        log.setStatus(1);
        log.setTaskId(taskId);
        log.setTaskName(task.getTaskName());
        iAppiumTaskLogService.save(log);
        List<AppiumTaskItem> taskItemList = iAppiumTaskItemService.initTaskItemList(taskId, null);
        AppiumUtil appiumUtil = new AppiumUtil();
        try {
            AndroidDriver androidDriver = appiumUtil.initAndroidDriver("http://39.106.184.70:4723/wd/hub", appiumDevice.getIp() + ":" + appiumDevice.getPort(), task.getAppPackage(), task.getAppActivity());
            if (taskItemList != null && taskItemList.size() > 0) {
                for (AppiumTaskItem appiumTaskItem : taskItemList) {
                    appiumUtil.runTask(androidDriver, appiumTaskItem, null);
                }
                log.setStatus(2);
                iAppiumTaskLogService.updateById(log);
                appiumDevice.setStatus(1);
                iAppiumDeviceService.updateById(appiumDevice);
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.setStatus(3);
            iAppiumTaskLogService.updateById(log);
            appiumDevice.setStatus(1);
            iAppiumDeviceService.updateById(appiumDevice);
        }
    }


}
